////// exo1.sci: //////
// exec exo1.sci



function y=f1(x)

y=x.^2;


endfunction

function y=f2(a,b,x)

y=x'*a*x/2-b'*x;

endfunction

function y=df2(a,b,x)

y=a*x-b;

endfunction

function z=f3(x,y)
z=2*x^2+3*x+y^2-2;
endfunction

function y=pasopt(a,b,x)
// a: matrice carrée
// b: vecteur vertical
// x: vecteur vertical

f=f2(a,b,x);
df=df2(a,b,x); 

yt=[];
xt=[];

for t=-100:0.01:100
 xtk=x+t*df;
 xt=[xt,xtk];
 ytk=f2(a,b,xtk);
 yt=[yt;ytk];

end

[u,v]=min(yt);
y=xt(:,v);


endfunction


function y=pasfixe(rho,a,b,x)

y=x-rho*df2(a,b,x);

endfunction



xx=-1:0.01:1;
yy=f1(xx);

[u,v]=min(yy)
w=xx(v) //f1(u);

close()

plot(xx,yy,u,w,'o')


a1=[4 0; 0 2];
b1=[-3;0];

x0=[3;-2]; //[3;2]; //[-3;2]; //[-3;-3]; //[-1;-1];//
rho=1/3; //0.001;
test=1;
eps=0.01;

k=0;
while (test>eps)&(k<100)  
//for k=1:20
   x0=pasfixe(rho,a1,b1,x0);
   test=abs(f2(a1,b1,x0)+9/8);
   k=k+1;
end

xsol=[-3/4;0];
err=norm(x0-xsol)
k

x0=[3;-2]; //[3;2]; //[-3;2]; //[-3;-3]; //[-1;-1];//
test=1;
eps=1e-6; //0.0001;

k=0;
tabx0=[x0];
y0=f2(a1,b1,x0)-2;
taby0=[y0];

while (test>eps)&(k<100)  
//for k=1:20
   x0=pasopt(a1,b1,x0);
   y0=f2(a1,b1,x0)-2;
   tabx0=[tabx0,x0];
   taby0=[taby0,y0];
   test=abs(y0+25/8);
   //test=abs(f2(a1,b1,x0)+9/8);
   k=k+1;
end



xsol=[-3/4;0];
err=norm(x0-xsol)
k
test

close()

t=linspace(-3,2,1000);
contour2d(t,t,f3,taby0,rect=[-3,-3,2,2]);
//contour2d(t,t,f3,20,rect=[-3,-3,2,2]);

x0x=tabx0(1,:);
x0y=tabx0(2,:);

x00=x0x(1);
y00=x0y(1);
x01=x0x($);
y01=x0y($);
xsol1=xsol(1);
xsol2=xsol(2);

plot(x0x,x0y,x00,y00,'*',x01,y01,'*',xsol1,xsol2,'o')


////
a2=[2 0; 0 2];
b2=[0;2];

x0=[1;-1];
rho=0.5; // 0.001;
test=1;
eps=0.01;

k=0;
while (test>eps)&(k<100)  
//for k=1:20
   x0=pasfixe(rho,a2,b2,x0);
   test=abs(f2(a2,b2,x0)+1);
   k=k+1;
end

xsol=[0;1];
err=norm(x0-xsol)
k

x0=[1;-1];
test=1;
eps=1e-6; //0.0001;

k=0;

tabx0=[x0];
while (test>eps)&(k<100)  
//for k=1:20
   x0=pasopt(a2,b2,x0);
   tabx0=[tabx0,x0];
   test=abs(f2(a2,b2,x0)+1);
   k=k+1;
end

xsol=[0;1];
err=norm(x0-xsol)
k
test

//////////



