////// exo2v2.sci: //////
// exec exo2v2.sci



function y=pasfixe(rho,df,x)

y=x-rho*df(x);

endfunction


function y=f3(x)
y=x.^4-7*x+8;
endfunction

function y=df3(x)
y=4*x.^3-7;
endfunction


rho=0.15; // 0.01; //0.1; //0.15;

xsol=(7/4)^(1/3);
minf3=f3(xsol);

x0=1.9; //1.8; //1.5; //2; //0; //1; //0;
eps=1e-6;
test=1;
k=0;

tabx0=[x0];
y0=f3(x0);
taby0=[y0];

while (test>eps)&(k<100)
  x0=pasfixe(rho,df3,x0);
  tabx0=[tabx0,x0];
  y0=f3(x0);
  taby0=[taby0,y0];
  test=abs(y0-minf3);
  k=k+1;
end

k
test

close()
xx=-0.5:0.01:2;
yy=f3(xx);

x01=tabx0(1);
y01=taby0(1);


plot(xx,yy,tabx0,taby0,x01,y01,'*',x0,y0,'o')


