////// exo3v2.sci: //////
// exec exo3v2.sci

function y=h1(x)
y=x(1)^2+x(2)^2-1;
endfunction

function y=h2(x)
y=1-x(1)+x(2);
endfunction


function z=g1(x,y)
z=x^2-y;
endfunction

function y=g(x)
y=x(1)^2-x(2);
endfunction

function y=dg(x)
y=x;
y(1)=2*y(1);
y(2)=-1;
endfunction






function y=pK(x)

y=x;
x1=x(1);
x2=x(2);
r=x1^2+x2^2;
s=x1+x2;
d=x2-x1;

if (r>=1)&(s>=1) then
   if x2<=0 then
     y(1)=1;
     y(2)=0;
   elseif (x1<=0) then
     y(1)=0;
     y(2)=1;
   else
     y=x/sqrt(r);
   end
end

if (s<=1) then
   if (d>=1) then 
      y(1)=0;
      y(2)=1;
   elseif (d<=-1) then
      y(1)=1;
      y(2)=0;
   else 
      y(1)=(1-d)/2;
      y(2)=(1+d)/2;
   end
end

    
endfunction

function [y,z]=pasfixeproj(rho,df,x)

z=x-rho*df(x);
y=pK(z);

endfunction

function y=pasfixe(rho,df,x)

y=x-rho*df(x);


endfunction

function y=pasfixepen(param,rho,df,x)

eps=1e-6;

x1=x(1);
x2=x(2);

dy=df(x);

if max(h1(x),0)>eps then 
dy=dy+4*h1(x)*[x1;x2]/param;
end

if max(h2(x),0)>eps then 
dy=dy-2*h2(x)*[1;1]/param;
end


y=x-rho*dy;



endfunction




close()
xx=-1:0.01:1;
yy1=sqrt(1-xx.^2);
yy2=-yy1;

plot(xx,yy1)
plot(xx,yy2)

xx=-2:0.01:3;
yy1=1-xx;
plot(xx,yy1)

t=-2:0.01:2;
contour2d(t,t,g1,20)


x=[0;0];
y=pK(x)
y1=y(1);
y2=y(2);
xx=0:0.01:y1;
yy=0:0.01:y2;
plot(xx,yy)
plot(0,0,'*',y1,y2,'o')


x=[1;1];
y=pK(x)
y1=y(1);
y2=y(2);
xx=y1:0.01:1;
yy=y2:0.01:1;
plot(xx,yy)
plot(1,1,'*',y1,y2,'o')

x=[0;2];
y=pK(x)
y1=y(1);
y2=y(2);

yy=1:0.01:2;
xx=zeros(yy);
plot(xx,yy)
plot(0,2,'*',y1,y2,'o')


x=[-1;1.5];
y=pK(x)
y1=y(1);
y2=y(2);
xx=-1:0.01:y1;
yy=1-xx/2;
plot(xx,yy)
plot(-1,1.5,'*',y1,y2,'o')


x=[2;-1.5];
y=pK(x)
y1=y(1);
y2=y(2);
xx=y1:0.01:2;
yy=-3*(xx-1)/2;
plot(xx,yy)
plot(2,-1.5,'*',y1,y2,'o')

rho=1; // 0.1;
eps=1e-6; //0.001;
x=[-1;1.5];//[1;1];//[-1;-1];//[0;0];//
tabx=[x];
taby=[x];

test=1;
k=0;

while (test>eps)&(k<50)
[x,y]=pasfixeproj(rho,dg,x);
tabx=[tabx,x];
taby=[taby,y];
test=abs(g(x)+1);
k=k+1;
end

test
k
x

xx1=tabx(1,:);
xx2=tabx(2,:);
x1=xx1(1);
x2=xx2(1);
x3=xx1($);
x4=xx2($);

xy1=taby(1,:);
xy2=taby(2,:);
y1=xy1(1);
y2=xy2(1);
y3=xy1($);
y4=xy2($);


close()
xx=-1:0.01:1;
yy1=sqrt(1-xx.^2);
yy2=-yy1;

plot(xx,yy1)
plot(xx,yy2)

xx=-2:0.01:3;
yy1=1-xx;
plot(xx,yy1)

plot(xx1,xx2,x1,x2,'*',x3,x4,'o')
plot(xy1,xy2,y1,y2,'*',y3,y4,'x')

///////////
rho=1;
param=0.1;
eps=0.1;
x=[0;0];
test=1;
k=0;

while (test>eps)&(k<100)

x=pasfixepen(param,rho,dg,x);
test=abs(g(x)+1);
k=k+1;
end

test
k

